# -*- coding: utf-8 -*-
'''
Created on 2010-7-21

@author: GL

Use to generate regular expressions
NOTE: it won't save your code, but will help you read and maintain regular expression.
'''
import sys

class GenReError(Exception):
    pass

def is_captured(p):
    if p[0] != '(' or p[-1] != ')':
        return False
    i = 0
    c = 0
    while i < len(p):
        ch = p[i]
        if '\\' == ch:
            i += 1
        elif '(' == ch:
            c += 1
        elif ')' == ch:
            c -= 1
            if c == 0 and i != len(p) - 1:
                return False
        i += 1
    if c != 0:
        raise GenReError('<%s> :( and ) not close' % p)
    return True
##Read note: p = pattern, ps =patterns,

has = hastext = lambda p : p and len(p) > 0
#是否捕获了
caped = captured = is_captured
#有名字则捕获
cap_if = cap_if_name = capture_if_name = lambda p, name = None:name and '(?P<%s>' % name + p + ')' or p
#捕获
cap = capture = lambda p, name = None : has(p) and(name and ('(?P<%s>%s)' % (name, p)) or caped(p) and p or '(%s)' % p)
nocap = no_cap = lambda p : caped(p) and p or (r'(?:%s)' % p)
#可有可无，小于等于1个
le1 = may = maybe = nullable = lambda p, name = None : cap(p, name) + '?'
#1个或多个
ge1 = many = multi = lambda p, name = None : cap(p, name) + '+'
#任意个
any = lambda p, name = None : cap(p, name) + '*'
#开始
starts = starts_with = lambda p: '^' + p
#结束
ends = ends_with = lambda p: p + '$'

#一组pattern中的任何一个
any_of = lambda ps, name = None: cap('|'.join(ps), name)

if_group = lambda g, yes, no:r"(?(%s)%s|%s)" % (g, yes, no)

#组合字符串
capjoin = in_turn = lambda * ps: ''.join([cap(v)for v in ps])
nocapjoin = lambda * ps :''.join(nocap(ps))
join = lambda * ps : ''.join(ps)

group_pairs = lambda pairs : ''.join(capture_if_name(pair[1], pair[0]) for pair in pairs)
list_to_pairs = lambda t : [(t[i << 1], t[i << 1 | 1 ]) for i in xrange(0, len(t) >> 1)]

pairs = lambda * args:list_to_pairs(args)

groups = lambda * args: group_pairs(list_to_pairs(args))

symbol = r"[^\w]"
space = r'\s'
spaces = any(space)

def _gen(p, name=None):
    if p == None:
        return None
    if type(p) == list:
        return len(p) == 1 and maybe(gen(p[0]), name) or any_of([_gen(v) for v in p], name)
    if type(p) == tuple:
        return cap_if(''.join([_gen(v) for v in p]), name)
    if type(p) == dict:
        l = [_gen(v, k)for k, v in p.items()]
        if len(l) == 1:
            return _gen(l[0], name)
        return _gen(l, name)
    if isinstance(p, basestring):
        r = cap_if(p, name)
        try:
            import re
            re.compile(r)
        except:
            print r
            print sys.exc_info()
        return r

def gen(*args, **kwargs):
    '''
    gen([reg]) = maybe(reg)
    gen(reg1,reg2,reg3) = gen(reg1)gen(reg2)gen(reg3)
    gen([reg1,reg2,reg3] = (gen(reg1)|gen(reg2)|gen(reg3))
    gen({name,reg}) = (?<name>gen(reg))
    gen(str) = str
    sample: gen('a','b',['c','d',('e',['f']),{'g':'h'}],{'x':'y'},{'l':'m'})
    (ab(c|d|(e(f)?)|(?P<g>h))(?P<x>y)(?P<l>m))
    '''
    a = _gen(args)
    b = _gen(kwargs)
    return a and b and a + b or a or b

def genre(*args, **kwargs):
    import re
    return re.compile(gen(*args, **kwargs))
